/* ############################# MPC License ############################## */
/* # Wed Nov 19 15:19:19 CET 2008                                         # */
/* # Copyright or (C) or Copr. Commissariat a l'Energie Atomique          # */
/* #                                                                      # */
/* # IDDN.FR.001.230040.000.S.P.2007.000.10000                            # */
/* # This file is part of the MPC Runtime.                                # */
/* #                                                                      # */
/* # This software is governed by the CeCILL-C license under French law   # */
/* # and abiding by the rules of distribution of free software.  You can  # */
/* # use, modify and/ or redistribute the software under the terms of     # */
/* # the CeCILL-C license as circulated by CEA, CNRS and INRIA at the     # */
/* # following URL http://www.cecill.info.                                # */
/* #                                                                      # */
/* # The fact that you are presently reading this means that you have     # */
/* # had knowledge of the CeCILL-C license and that you accept its        # */
/* # terms.                                                               # */
/* #                                                                      # */
/* # Authors:                                                             # */
/* #   - PERACHE Marc marc.perache@cea.fr                                 # */
/* #                                                                      # */
/* ######################################################################## */
static char sctk_net_network_mode[4096];

static void
sctk_net_init_driver_init_modules (char *mode)
{
  char tmp[4096];

  /*
     INIT FUNC FOR MODULES
   */
  sctk_rpc_init_func (sctk_net_rpc_driver, sctk_net_rpc_retrive_driver,
		      sctk_net_rpc_send_driver);
  sctk_send_init_func (sctk_net_send_ptp_message_driver,
		       sctk_net_copy_message_func_driver,
		       sctk_net_free_func_driver);
  sctk_collective_init_func (sctk_net_collective_op_driver);
  sctk_net_get_pages_init (sctk_net_get_pages_driver);

  sctk_iso_alloc_stat (tmp);

  sctk_net_adm_poll = sctk_net_adm_poll_func;
  sctk_net_ptp_poll = sctk_net_ptp_poll_func;

  sprintf (sctk_net_network_mode, "%s (RDMA) (%s)", mode, tmp);
  sctk_network_mode = sctk_net_network_mode;
}

static void
sctk_net_preinit_driver_init_modules ()
{
  /*
     ALLOCATIONS AND MODULES INIT
   */
  sctk_net_preinit_rpc (1);
  sctk_net_preinit_collectives (1);
  sctk_net_preinit_ptp (1);
}

static void
sctk_net_preinit_driver_init_modules_no_global ()
{
  /*
     ALLOCATIONS AND MODULES INIT
   */
  sctk_net_preinit_rpc (0);
  sctk_net_preinit_collectives (0);
  sctk_net_preinit_ptp (0);
}
